global gFileName, gFolderList, gFileList, gDirList, gDxrList, gCstList, gIniList, gDllList, gTxtList, gPicList, gSndList, gMovList

on launchMovie
  if the shiftDown then
    halt()
  end if
  siftFileNames()
  set gFileName to lowercase("mainmenu")
  attemptOpen(gDxrList, gFileName & ".dxr")
  if the result = 1 then
    exit
  end if
  attemptOpen(gDirList, gFileName & ".dir")
  if the result = 1 then
    exit
  end if
  attemptOpen(gCstList, gFileName & ".cst")
  if the result = 1 then
    exit
  end if
  set x to "I could not find any data files pertaining to this application."
  set x to x & RETURN & RETURN
  set x to x & "Please refer to any accompanying 'Read Me' files "
  set x to x & "for further directions."
  alert(x)
  halt()
end

on siftFileNames
  set gFolderList to []
  set gFileList to []
  set gDirList to []
  set gDxrList to []
  set gCstList to []
  set gIniList to []
  set gDllList to []
  set gTxtList to []
  set gPicList to []
  set gSndList to []
  set gMovList to []
  set the itemDelimiter to "."
  set gFileName to lowercase(item 1 of the movie)
  repeat with x = 1 to the maxinteger
    set fileX to getNthFileNameInFolder(the pathName, x)
    set fileX to lowercase(fileX)
    case fileX of
      EMPTY:
        exit repeat
      otherwise:
        set fileExtension to item 2 of fileX
        case fileExtension of
          EMPTY:
            append(gFolderList, fileX)
          otherwise:
            append(gFileList, fileX)
            case fileExtension of
              "dir":
                append(gDirList, fileX)
              "dxr":
                append(gDxrList, fileX)
              "cst":
                append(gCstList, fileX)
              "ini":
                append(gIniList, fileX)
              "dll":
                append(gDllList, fileX)
              "txt", "dat", "dta":
                append(gTxtList, fileX)
              "pct", "pic", "gif":
                append(gPicList, fileX)
              "aif", "snd", "wav":
                append(gSndList, fileX)
              "avi", "mov":
                append(gMovList, fileX)
            end case
        end case
    end case
  end repeat
  set the itemDelimiter to ","
end

on attemptOpen whichList, whichName
  case getPos(whichList, whichName) of
    0:
      put "Attempt to open '" & whichName & "' failed."
      return 0
      exit
    otherwise:
      put "Attempt to open '" & whichName & "' successful."
      go(1, the pathName & whichName)
      return 1
      abort()
      exit
  end case
end

on makeList listList
  if listp(listList) then
    set countList to count(listList)
    repeat with x = 1 to countList
      set whichList to getAt(listList, x)
      do("global " & whichList)
      do("set " & whichList & "=[ ]")
      do("sort " & whichList)
    end repeat
  else
    if stringp(listList) then
      do("global " & listList)
      do("set " & listList & "=[ ]")
      do("sort " & listList)
    end if
  end if
end

on lowercase whichPhrase
  set newPhrase to EMPTY
  set numChars to the number of chars in whichPhrase
  repeat with x = 1 to numChars
    set charX to char x of whichPhrase
    set charToNumX to charToNum(charX)
    if (charToNumX > 64) and (charToNumX < 91) then
      set charX to numToChar(charToNumX + 32)
    end if
    set newPhrase to newPhrase & charX
  end repeat
  return newPhrase
end

on uppercase whichPhrase
  set newPhrase to EMPTY
  set numChars to the number of chars in whichPhrase
  repeat with x = 1 to numChars
    set charX to char x of whichPhrase
    set charToNumX to charToNum(charX)
    if (charToNumX > 96) and (charToNumX < 123) then
      set charX to numToChar(charToNumX - 32)
    end if
    set newPhrase to newPhrase & charX
  end repeat
  return newPhrase
end
